<?php

$objects_in_file = array(
                        'Blocker',
                        'DeathZone',
                        'TBlocker',
                        'HookOut',
                        'SObstacle',
                        'MObstacle',
                        'OtherS',
                        'HookIn',
                        'InvertedT',
                        'XOGram',
                        'VerticalBlocker'
                        );
                        
class DeathZone extends GridObject {
    var $growth=null;
    
    function DeathZone($position=null, $height=null, $size=1, $growth=null) {
        // Initialize the base class
        $this->GridObject($position, $height, $size, $growth);

        $this->type = 'zone';
    }
}

// This class shows one way to make points available.  Since it's a wall class,
//   we don't need to generate the xml here, the base class can do it for us
class Blocker extends GridObject {
    function Blocker($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->_AddPoint(-10,0);
        $this->_AddPoint(10,0);

        // We don't need to do this, since wall is the default type, but we do it
        // to show how you can do it
        $this->type = 'wall';
    }
}

class TBlocker extends GridObject {
    function TBlocker($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('x' => 0, 'y' => -10),
                            array('x' => 0, 'y' => 10),
                            array('x' => -10, 'y' => 10),
                            array('x' => 10, 'y' => 10)
                        );
    }
}

class HookOut extends GridObject {
    function HookOut($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                             array('x' => -10, 'y' => -5),
                             array('x' => -8, 'y' => 5),
                             array('x' => 8, 'y' => 5),
                             array('x' => 10, 'y' => -5)
                             );
    }
}

class MObstacle extends GridObject {
    function MObstacle($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('x' => -10, 'y' => -5),
                            array('x' => -5, 'y' => 5),
                            array('x' => 0, 'y' => -5),
                            array('x' => 5, 'y' => 5),
                            array('x' => 10, 'y' => -5)
                             );
    }
}

class SObstacle extends GridObject {
    function SObstacle($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('x' => -5, 'y' => -4),
                            array('x' => -4, 'y' => -5),
                            array('x' => 4, 'y' => -5),
                            array('x' => 5, 'y' => -4),
                            array('x' => 5, 'y' => -1),
                            array('x' => 4, 'y' => 0),
                            array('x' => -4, 'y' => 0),
                            array('x' => -5, 'y' => 1),
                            array('x' => -5, 'y' => 4),
                            array('x' => -4, 'y' => 5),
                            array('x' => 4, 'y' => 5),
                            array('x' => 5, 'y' => 4)
                             );
    }
}

class OtherS extends GridObject {
    function OtherS($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('y' => -5, 'x' => -4),
                            array('y' => -4, 'x' => -5),
                            array('y' => 4, 'x' => -5),
                            array('y' => 5, 'x' => -4),
                            array('y' => 5, 'x' => -1),
                            array('y' => 4, 'x' => 0),
                            array('y' => -4, 'x' => 0),
                            array('y' => -5, 'x' => 1),
                            array('y' => -5, 'x' => 4),
                            array('y' => -4, 'x' => 5),
                            array('y' => 4, 'x' => 5),
                            array('y' => 5, 'x' => 4)
                             );
    }
}

class HookIn extends GridObject {
    function HookIn($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('x' => -8, 'y' => -5),
                            array('x' => -10, 'y' => 5),
                            array('x' => 10, 'y' => 5),
                            array('x' => 8, 'y' => -5)
                             );
    }
}

class InvertedT extends GridObject {
    function InvertedT($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('X' => 0, 'Y' => -20),
                            array('X' => 0, 'Y' => 20),
                            array('X' => -10, 'Y' => 10),
                            array('X' => 10, 'Y' => 10)
                             );
    }
}

class XOGram extends GridObject {
    function XOGram($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                            array('x' => 10, 'y' => 20),
                            array('x' => 0, 'y' => 0),
                            array('x' => 10, 'y' => 0),
                            array('x' => 0, 'y' => 20),
                            array('x' => 10, 'y' => 20)
                             );
    }
}

class VerticalBlocker extends GridObject {
    function VerticalBlocker($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);
        
        $this->points = array(
                            array('x' => 0, 'y' => 10),
                            array('x' => 0, 'y' => -10)
                            );
    }
}

// This is a template to use to create new objects.  You should create them in your own
// file and leave this one alone
/*
class extends GridObject {
    function ($position=null, $height=null, $size=1, $growth=0) {
        $this->GridObject($position, $height, $size, $growth);

        $this->points = array(
                             );
    }
}
*/
?>